###### HTTP request with httr ######
library(httr)
library(magrittr)

# https://api.ratesapi.io/api/latest?base=USD&symbols=JPY
resp <- GET('https://api.ratesapi.io/',
            path = 'api/latest',
            query = list(base = "USD", symbols = "JPY"))

resp$url
resp$status_code

# Return parsed content
content(resp)
# Return raw string (JSON in this case)
content(resp, as = "text")


rlads <- GET("https://rlads2019.github.io/")
# Return raw HTML string
content(rlads, as = "text")


###### parse JSON in R ######
json_str1 = '{
  "name": "美髮",
  "subscriptionCount": 1838,
  "subscribed": false,
  "topics": ["剪髮","染髮","洗髮"],
  "postThumbnail": {
    "size": null
  }
}'
jsonlite::fromJSON(json_str1, simplifyVector = F)


# Convert R's list to JSON string
r_list <- list(
  name = "美髮",
  subscriptionCount = 1838,
  subscribed = FALSE,
  postThumbnail = list(
    size = NULL
  ),
  topics = list("剪髮","染髮")
)
jsonlite::toJSON(r_list, null = "null", auto_unbox = TRUE)
